"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var visitor_1 = require("./visitor");
var antlr4 = require('antlr4');
function parseAst(options) {
    var input = options.input;
    var _a = getParserForLanguage(options.language), Laxer = _a.Laxer, Parser = _a.Parser;
    var chars = new antlr4.InputStream(input);
    var lexer = new Laxer(chars);
    var tokens = new antlr4.CommonTokenStream(lexer);
    var parser = new Parser(tokens);
    //  parser.buildParseTrees = true;
    var tree = parser.compilationUnit();
    if (tree.exception) {
        throw new Error('Parser exception: ' + tree.exception);
    }
    var visitor = new visitor_1.Visitor(options);
    tree.accept(visitor);
    return visitor_1.getVisitorResult();
}
exports.parseAst = parseAst;
function getParserForLanguage(language) {
    if (language === 'c') {
        return {
            Laxer: require('./grammar/c/CLexer').CLexer,
            Parser: require('./grammar/c/CParser').CParser
        };
    }
    else {
        throw new Error('Language unknown: ' + language);
    }
}
//# sourceMappingURL=parseAst.js.map