"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var n = {
    children: []
};
function getVisitorResult() {
    return n.children[0];
}
exports.getVisitorResult = getVisitorResult;
var Visitor = /** @class */ (function () {
    function Visitor(options) {
        this.options = options;
    }
    Visitor.prototype.visitChildren = function (ctx) {
        var _this = this;
        if (!ctx) {
            return;
        }
        var node = this.getNode(ctx);
        n.children.push(node);
        if (ctx.children) {
            var previous = n;
            n = node;
            var result = ctx.children.map(function (child) {
                if (child.children && child.children.length != 0) {
                    var c = _this.getNode(child);
                    var result_1 = child.accept(_this);
                    return result_1;
                }
                else {
                    return child.getText();
                }
            });
            n = previous;
            return result;
        }
        return node;
    };
    Visitor.prototype.getNode = function (ctx) {
        return {
            type: ctx.parser.ruleNames[ctx.ruleIndex] || ctx.constructor.name,
            start: this.getLocation(ctx.start),
            stop: this.getLocation(ctx.stop),
            // exception: ctx.exception,
            // invokingState: ctx.invokingState,
            children: []
        };
    };
    Visitor.prototype.getLocation = function (start) {
        var source = start.source.find(function (e) { return typeof e.strdata === 'string'; });
        return {
            // token: start.getTokenSource().text,
            type: start.type,
            // channel: start.channel,
            start: start.start,
            stop: start.stop,
            // tokenIndex: start.tokenIndex,
            line: start.line,
            column: start.column,
            text: start.text,
            source: this.options.includeSource && source && source.strdata
        };
    };
    return Visitor;
}());
exports.Visitor = Visitor;
//# sourceMappingURL=visitor.js.map